require 'ostruct'
require 'image.rb'

class RSSParser < Parser
  def parse( xml )
    images = []
    xml.each_element( '//item' ) do |item|
      image = Image.new
      item.each_element( 'title' ) { |l| image.title = l.text.to_s; }  
      item.each_element( 'link' ) { |l| image.link = l.text.to_s; }  
      item.each_element( 'description' ) { |l| image.description = l.text.to_s; }
      item.each_element( 'jisha:date' ) { |l| image.date = l.text.to_s; }
      item.each_element( 'jisha:md5sum' ) { |l| image.md5sum = l.text.to_s; }
      item.each_element( 'jisha:distro' ) { |l| image.distro = l.text.to_s; }
      item.each_element( 'jisha:size' ) { |l| image.size = l.text.to_s; }
      images << image
    end

    return images
  end
end

class RSSFactory < ParserFactory
  def get_type()
    return "RSS"
  end
  
  def create()
    return RSSParser.new()
  end
end
